#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  senaria1_step2.pl
#
#        USAGE:  perl senaria1_step2.pl <in.low_quality.sam> <out.fq>
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  thre University of Hong Kong
#      VERSION:  1.0
#      CREATED:  Monday, March 17, 2014 18:52:54 HKT
# 
#===============================================================================

use strict;
use warnings;

die"perl $0 <in.low_quality.sam> <out.fq> <gap size> <clip size>\n"unless(@ARGV==4);
my $sam = shift;
my $out = shift;
my $gap = shift;
my $clip = shift;

open S, "$sam"||die$!;
open O, ">$out"||die$!;

while (<S>){
	chomp;
	my @line = split/\s+/,$_;
	my @base = split//, $line[9];
	my @qual = split//, $line[10];
	my $read = "$line[0]-$line[1]-$line[2]-$line[3]-$line[4]-$line[5]";
	for my $i ($clip..($#base-$clip)){
		if( (($i-20) % $gap) ){
			next;
		}
		my $bfa = $base[0];
		my $qfa = $qual[0];
		my $bra;
		my $qra;
		my $bfb = $base[$i];
		my $qfb = $qual[$i];
		my $brb;
		my $qrb;
			
		for my $fi (1..($i-1)){
			$bfa .= $base[$fi];
			$qfa .= $qual[$fi];
		}
			$bra = reverse $bfa;
			$qra = reverse $qfa;
	
		for my $ri (($i+1)..$#base){
			$bfb .= $base[$ri];
			$qfb .= $qual[$ri];
		}
		$brb = reverse $bfb;
		$qrb = reverse $qfb;

		my $nfa = "\@$read-$i-F-A";
		my $nra = "\@$read-$i-R-A";
		my $nfb = "\@$read-$i-F-B";
		my $nrb = "\@$read-$i-R-B";

		print O "$nfa\n$bfa\n+\n$qfa\n";
		print O "$nfb\n$bfb\n+\n$qfb\n";
	}

}
close O;
close S;
