#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  extract_candidate_reads.pl
#
#        USAGE:  ./extract_candidate_reads.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Tuesday, October 29, 2013 07:24:22 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die "perl $0 <in.sam> <out.sam> <chrID> <macth/not>\n"unless(@ARGV==4);
my $in = shift;
my $out = shift;
my $chr = shift;
my $match = shift;
$chr =~ s/chr//g;
$chr =~ s/Chr//g;

my %cand;
open I, $in||die$!;
while (<I>){
	chomp;
	my @line = split/\s+/,$_;
	$line[2] =~ s/chr//g;
	$line[2] =~ s/Chr//g;
	unless ($line[0] =~ /^@/){
		if ($line[2] ne $chr){
			next;
		}
		my @rd = split/-/,$line[0];
		my $ab = pop @rd;
		my $fr = pop @rd;
		my $rdi = join"-", @rd;
		if ($match eq "macth"){
			if ($line[5] =~ /^\d+M$/){
				if ($line[4] > 0){
					$cand{$rdi}{"$fr$ab"} = $line[1];
				}
			}
		}else {
			if ($line[4] > 0){
				$cand{$rdi}{"$fr$ab"} = $line[1];
			}
		}
	}
}
close I;

open C, ">$out.reads_list"||die$!;
my %cand_out;
for my $rd (keys %cand){
	if ( (exists $cand{$rd}{"FA"}) && (exists $cand{$rd}{"FB"}) ){
		if (  (($cand{$rd}{"FA"} eq "0") && ($cand{$rd}{"FB"} eq "16"))  ||  (($cand{$rd}{"FA"} eq "16") && ($cand{$rd}{"FB"} eq "0"))   ){
			$cand_out{$rd} = "";
			print C "$rd\n";
		}
	}
}
close C;

%cand = ();

open I, $in||die$!;
open O, ">$out"||die$!;
while (<I>){
	chomp;
	my @line = split/\s+/,$_;
	$line[2] =~ s/chr//g;
	$line[2] =~ s/Chr//g;
	if ($line[0] =~ /^@/){
		print O "$_\n";
	}elsif($line[2] eq $chr) {
		my @rd = split/-/,$line[0];
		my $ab = pop @rd;
		my $fr = pop @rd;
		my $rdi = join"-", @rd;

		if (exists $cand_out{"$rdi"}){
			print O "$_\n";
		}
	}
}
close I;
close O;
