#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  extract_candidate_reads.pl
#
#        USAGE:  ./extract_candidate_reads.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Tuesday, October 29, 2013 07:24:22 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die "perl $0 <in.sam> <out.sam> <chrID> <macth/not>\n"unless(@ARGV==4);
my $in = shift;
my $out = shift;
my $chr = shift;
my $match = shift;
$chr =~ s/chr//g;
$chr =~ s/Chr//g;

my $readid;
my $fa_flag;
my $fa_match = 0;
my $fa_prt;
my $fb_flag;
open I, $in||die$!;
open O, ">$out"||die$!;
while (<I>){
	chomp;
	my @line = split/\s+/,$_;
	$line[2] =~ s/chr//g;
	$line[2] =~ s/Chr//g;
	if ($line[0] =~ /^@/){
		print O "$_\n";
	}else {
		my @rd = split/-/,$line[0];
		my $ab = pop @rd;
		my $fr = pop @rd;
		my $rdi = join"-", @rd;

		if ($line[0] =~ /-F-A$/){
			$fa_flag = $line[1];
			$readid = $rdi;
			$fa_prt = $_;
			if ($match eq "macth"){
				if ($line[5] =~ /^\d+M$/){
					if ($line[4] > 0){
						$fa_match = 1;
					}
				}
			}elsif ($line[4] > 0) {
				$fa_match = 1;
			}

			next;

		}elsif ($line[0] =~ /-F-B$/) {
			$fb_flag = $line[1];
			if ($readid ne $rdi){
				die"ERROR!!please check your step3 output sam format: each -F-A(forward fragment A read) must followed by a correspond -F-B(forward fragment B read)\n";
			}
			unless ( (($fa_flag eq "0")&&($fb_flag eq "16")) || (($fa_flag eq "16")&&($fb_flag eq "0")) ){
			
				$fa_match = 0;
				next;
			}
			if ($line[2] ne $chr){
				$fa_match = 0;
				next;
			}
		
			if ($match eq "macth"){
				if ($line[5] =~ /^\d+M$/){
					if ($line[4] > 0){
						
						if ($fa_match == 1){
							print O "$fa_prt\n$_\n";
						}
					
					}
				}
			}else {
				if ($line[4] > 0){
				
					if ($fa_match == 1){
						print O "$fa_prt\n$_\n";
					}
				
				}
			}
			$fa_match = 0;
		}
	}
}
close I;
close O;
