#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  step5_get_inversion_region.pl
#
#        USAGE:  ./step5_get_inversion_region.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Friday, November 22, 2013 06:05:05 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die "perl $0 <in.sam.candidate> <out.inversion.region> <chr ID> <maximum inversion to be included>\n"unless (@ARGV==4);
my $in = shift;
my $out = shift;
my $chr = shift;
my $maxinv = shift;
$chr =~ s/chr//g;
$chr =~ s/Chr//g;

open I, "$in"||die$!;
my %reads;
while (<I>){
	chomp;
	my @line = split/\s+/,$_;

	unless ($line[0] =~ /^@/){
		$line[2] =~ s/chr//g;
		$line[2] =~ s/Chr//g;
		
		if ($line[2] ne $chr){
			next;
		}

		my @rd = split/-/,$line[0];
		my $ab = pop @rd;
		my $fr = pop @rd;
		my $winID = pop @rd;
		my $rdi = join"-", @rd;
		my $len =0;
		if ($line[5]=~/(\d+)M/){
			$len = $1;
		}
		my $pos = $line[3] + ($len-1);
		if ((!exists $reads{$rdi}{"S"})||($reads{$rdi}{"S"} > $line[3])){
			$reads{$rdi}{"S"} = $pos;
		}

		if ((!exists $reads{$rdi}{"E"})||($reads{$rdi}{"E"} < $pos)){
			$reads{$rdi}{"E"} = $pos;
		}
	}
}
close I;

open O, ">$out"||die$!;
open OT, ">$out.large_span"||die$!;
print O "#ChrID\tinversion_start\tinversion_end\treads_id\n";
for my $r (sort keys %reads){
	if ((!exists $reads{$r}{"S"}) || (!exists $reads{$r}{"E"})){
		print "WARNING: reads $r is truncated! please check!\n";
	}else {
		my $st = $reads{$r}{"S"};
		my $ed = $reads{$r}{"E"};
		if (($ed-$st+1)>$maxinv){
			print OT "chr$chr\t$st\t$ed\t$r\n";
		}else{
			print O "chr$chr\t$st\t$ed\t$r\n";
		}
	}
}
close O;
close OT;
