#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  step6_merge_inversion.pl
#
#        USAGE:  ./step6_merge_inversion.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Friday, November 22, 2013 06:35:27 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die "perl $0 <in.candidate.inversion> <out.candidate.inversion.merge> <chrID>\n"unless(@ARGV==3);
my $in = shift;
my $out = shift;
my $chr = shift;
$chr =~ s/chr//g;
$chr =~ s/Chr//g;

my %merg;

open I, "grep -v ChrID $in|sort -nk 2|"||die$!;
my $n = 0;
my $ivn = 0;
while (<I>){
	chomp;
	$n++;
	my @line = split/\s+/,$_;
	if ($n == 1){
		$ivn = 1;
		$merg{$ivn}[0] = 1;
		$merg{$ivn}[1] = $line[1];
		$merg{$ivn}[2] = $line[2];
		$merg{$ivn}[3] = $line[1];
		$merg{$ivn}[4] = $line[2];
		$merg{$ivn}[5] = "$line[3]|$line[1]-$line[2]";
	}else {
		my $mark = 0;
		for my $iv (keys %merg){
			if (  (($line[1]>=$merg{$iv}[1])&&($line[1]<=$merg{$iv}[2]))  ||  (($line[2]>=$merg{$iv}[1])&&($line[2]<=$merg{$iv}[2]))  ){
				$merg{$iv}[0] ++;
				$mark ++;
				if ($merg{$iv}[1] > $line[1]){
					$merg{$iv}[1] = $line[1];
				}
				if ($merg{$iv}[2] < $line[2]){
					$merg{$iv}[2] = $line[2];
				}
				if ($merg{$iv}[3] < $line[1]){
					$merg{$iv}[3] = $line[1];
				}
				if ($merg{$iv}[4] > $line[2]){
					$merg{$iv}[4] = $line[2];
				}
				$merg{$iv}[5] .= ",$line[3]|$line[1]-$line[2]";
			}
		}
		if ($mark == 0){
			$ivn ++;
			$merg{$ivn}[0] = 1;
			$merg{$ivn}[1] = $line[1];
			$merg{$ivn}[2] = $line[2];
			$merg{$ivn}[3] = $line[1];
			$merg{$ivn}[4] = $line[2];
			$merg{$ivn}[5] = "$line[3]|$line[1]-$line[2]";
		}
	}
}
close I;

open O, ">$out"||die$!;
print O "#ChrID\tShared_inversion_start\tShared_inversion_end\tInversion_length\tInversion_range(Start-End)\tNumber_of_reads_covered\tReads_info\n";
for my $iv (sort{$a<=>$b} keys %merg){
	my $st = $merg{$iv}[3];
	my $ed = $merg{$iv}[4];
	if ($merg{$iv}[3] > $merg{$iv}[4]){
		$st = $merg{$iv}[4];
		$ed = $merg{$iv}[3];
	}
	my $len = ($ed-$st)+1;
	print O "chr$chr\t$st\t$ed\t$len\t$merg{$iv}[1]-$merg{$iv}[2]\t$merg{$iv}[0]\t$merg{$iv}[5]\n";
}
close O;
