#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  split_reads.pl
#
#        USAGE:  ./split_reads.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Tuesday, October 29, 2013 03:56:54 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die"perl $0 <in.bam> <out.fq> <chrID> <samtools> <gap size> <minimum window size>\n"unless(@ARGV==6);
my $bam = shift;
my $out = shift;
my $chr = shift;
my $samtools = shift;
my $gap = shift;
my $minwin = shift;

$chr =~ s/chr//g;
$chr =~ s/Chr//g;

open S, "$samtools view $bam|"||die$!;
open O, ">$out"||die$!;

my %unmap = ("101"=>"","117"=>"","69"=>"","77"=>"","133"=>"","165"=>"","181"=>"","141"=>"","4"=>"","125"=>"","189"=>"","93"=>"","109"=>"","157"=>"","173"=>"","20"=>"");

while (<S>){
	chomp;
	my @line = split/\s+/,$_;
		$line[2] =~ s/chr//g;
		$line[2] =~ s/Chr//g;
		if (($line[2] eq $chr) || ($chr eq "all")||($line[2] eq '*')){
			if (exists $unmap{$line[1]}){	
				my @base = split//, $line[9];
				my @qual = split//, $line[10];
				my $readm = ($#base - 40);
				my $gapm = int($readm/$gap);
				for my $win (1..$gapm){
					$win = $win*$gap;
					if ($win >= $minwin){
						for my $i (6..($#base-5-$win)){
							if ( ($i % $gap) == 0){
								my $ba = $base[0];
								my $qa = $qual[0];
								my $bb = $base[$i];
								my $qb = $qual[$i];
								my $bc = $base[$i+$win+1];
								my $qc = $qual[$i+$win+1];
						
								for my $ai (1..($i-1)){
									$ba .= $base[$ai];
									$qa .= $qual[$ai];
								}

								for my $bi (($i+1)..($i+$win)){
									$bb .= $base[$bi];
									$qb .= $qual[$bi];
								}

								for my $ci (($i+$win+2)..$#base){
									$bc .= $base[$ci];
									$qc .= $qual[$ci];
								}

								my $brb = reverse $bb;
								my %change = (
									"A" => "T",
									"T" => "A",
									"C" => "G",
									"G" => "C",
									"N" => "N"
								);
								my @brb = split//,$brb;
								$brb = "";
								for my $bi (@brb){
									if (!exists $change{$bi}){
										$brb .= $bi;
									}else {
										$brb .= $change{$bi};
									}
								}
								my $qrb = reverse $qb;

								my $name ="\@$line[0]-$line[1]-$line[2]-$line[3]-$line[4]-$line[5]-$i-win$win";
								my $base = $ba.$brb.$bc;
								my $qual = $qa.$qrb.$qc;
								print O "$name\n$base\n+\n$qual\n";
							}
						}
					}
				}
			}
		}
}
close O;
close S;
