#!/usr/bin/perl 
#===============================================================================
#
#         FILE:  step4-5_get_inversion_region.pl
#
#        USAGE:  ./step4-5_get_inversion_region.pl  
#
#  DESCRIPTION:  
#
#      OPTIONS:  ---
# REQUIREMENTS:  ---
#         BUGS:  ---
#        NOTES:  ---
#       AUTHOR:  Ruoyan Chen (cry), chenry@hku.hk
#      COMPANY:  Hong Kong University
#      VERSION:  1.0
#      CREATED:  Friday, November 29, 2013 02:26:48 HKT
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;

die "perl $0 <in.sam> <out.inversion> <chrID> <match/not>\n"unless (@ARGV==4);
my $in = shift;
my $out = shift;
my $chr = shift;
my $match = shift;
$chr =~ s/chr//g;
$chr =~ s/Chr//g;

my %out;
my $readl=0;
open I, $in||die$!;
while (<I>){
	chomp;
	my @line = split/\s+/,$_;
	unless ($line[0] =~ /^@/){
		$line[2] =~ s/chr//g;
		$line[2] =~ s/Chr//g;
		if ($readl < length($line[9])){
        	        $readl = length($line[9]);
	        }

		if ($line[2] ne $chr){
			next;
		}
		my $mark = 0;
		if (($match eq "match") && ($line[5] =~ /^\d+M$/) && ($line[4] > 0)){
			$mark ++;
		}
		if (($match ne "match") && ($line[4] > 0)){
			$mark ++;
		}
		if ($mark > 0){
			my @read = split/-/,$line[0];
			my $win = pop @read;
			my $split = pop @read;
			my $readname = join"-", @read;
			$win =~ s/win//g;
			my ($st,$ed) = (0,0);
			if ($line[1] == 0){
				$st = $line[3] + $split;
				$ed = $line[3] + $split + $win;
			}elsif ($line[1] == 16){
				$st = $line[3] + ($readl - ($split + $win + 1));
				$ed = $line[3] + ($readl - ($split + 1));
			}
			if (exists $out{$readname}){
				if ($out{$readname}[0] > $st){
					$out{$readname}[0] = $st;
				}
				if ($out{$readname}[1] < $ed){
					$out{$readname}[1] = $ed;
				}
			}else {
				$out{$readname}[0] = $st;
				$out{$readname}[1] = $ed;
			}
		}
	}
}
close I;

open O, ">$out"||die$!;
print O "#ChrID\tinversion_start\tinversion_end\treads_id\n";
for my $rd (sort keys %out){
	if (($out{$rd}[1]-$out{$rd}[0])<=$readl){
		print O "chr$chr\t$out{$rd}[0]\t$out{$rd}[1]\t$rd\n";
	}
}
close O;
