#!/usr/bin/perl -w
use strict;

die "perl $0 <in.srinversion.merge> <out.merge>\n"unless(@ARGV==2);
my $in = shift;
my $out = shift;

open I, "grep -v ChrID $in|sort -nk 2|"||die$!;
open O, ">$out"||die$!;
my ($chr,$st,$ed,$len,$rana,$ranb,$depth,$info);
print O "#ChrID\tShared_inversion_start\tShared_inversion_end\tInversion_length\tInversion_range(Start-End)\tNumber_of_reads_covered\tReads_info\n";
while (<I>){
	chomp;
	my @line = split/\s+/,$_;
	if (!$chr){
		$chr = $line[0];
		$st = $line[1];
		$ed = $line[2];
		$len = $line[3];
		($rana,$ranb) = split/-/,$line[4];
		$depth = $line[5];
		$info = $line[6];
	}elsif (($line[1] - $ed) < 10){
		$ed = $line[2];
		$ranb = (split/-/,$line[4])[1];
		$depth += $line[5];
		$info .= ";$line[6]";
	}else {
		print O "$chr\t$st\t$ed\t$len\t$rana-$ranb\t$depth\t$info\n";
		$chr = $line[0];
                $st = $line[1];
                $ed = $line[2];
                $len = $line[3];
                ($rana,$ranb) = split/-/,$line[4];
                $depth = $line[5];
                $info = $line[6];
	}
}
print O "$chr\t$st\t$ed\t$len\t$rana-$ranb\t$depth\t$info\n";
close O;
close I;
